︠374eb4dd-7ee6-4c8c-829c-1423fbd3f809s︠
reset
︡1d2192a1-fc99-4d34-83fc-c31c5ac70bb8︡{"stdout":"<function reset at 0x7f80c5c78050>\n"}︡{"done":true}
︠22d8c61f-3846-4bcb-bc8d-cb6a4c49a7d1s︠
#Useful commands
#Dot product
var('a b c d');
u=vector((a,b)); v=vector((c,d))# Syntax for defining vectors u, v
u.dot_product(v)# syntax for the dot product <u,v>

︡a273e0b6-d0f4-424f-bb73-159a9df74a2b︡{"stdout":"(a, b, c, d)"}︡{"stdout":"\n"}︡{"stdout":"a*c + b*d\n"}︡{"done":true}
︠9b3eb4bd-f12d-4720-b142-824ae1dff5e7s︠
norm(vector((3,4)))# magnitude,or length, of the vector
︡86d3a3ef-11df-42ce-950a-555d52177b6b︡{"stdout":"5\n"}︡{"done":true}
︠94ce4091-3e2d-45fe-b343-4da14fd39a24s︠
norm(vector((2,2)))
︡ce85a2f8-f919-4959-8ce0-4c03343341fe︡{"stdout":"2*sqrt(2)\n"}︡{"done":true}
︠87a824dd-e9d0-4ab0-bc62-336a0e34a8b7s︠
#Alternatively,the norm of a vector v can be found "from scratch" as (v.dot_product(v))^0.5

︡7f52fbf8-47e2-44ea-b1ea-b36721ce06a4︡{"done":true}
︠8440aa64-5c0a-404e-bd5d-05df14b73331s︠
arrow((3,4),(3+2,4-1),figsize=[3,2])# Syntax for plotting a vector
︡c36338c2-9c75-4e46-bb4c-812ea35c8366︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/307/tmp_NHohI1.svg","show":true,"text":null,"uuid":"72be1f93-b59c-4893-a440-f7ed21a84013"},"once":false}︡{"done":true}
︠56fcd9cc-f524-4461-bbc6-2fa979eabb39︠
︡9009d9d3-c891-465c-b2db-4634b40932ff︡
︠1743b29d-bd3f-479e-a078-16e1999b7a8es︠
#Exercise 1. Make a CAS function angle_and_proj(u,v) that takes two list of length 2 each, makes the lists into 2D vectors and returns
#• the angle between the vectors (in radians)
#• the projection of the first vector on the direction of the second vector
#Test your code on example of your choice.
︡e496c5df-984f-4f6a-9fae-0651a71ac7d3︡{"done":true}
︠b00bcb1c-4e2b-47dd-a5e5-c9de8fe22e75s︠
vec=[2,-4];V=vector(vec);type(V)
︡499ba84e-6fec-4c84-8e04-68e7c2b01768︡{"stdout":"<type 'sage.modules.vector_integer_dense.Vector_integer_dense'>\n"}︡{"done":true}
︠e1f8f2be-12f3-488e-b8dc-2036083b1c13s︠
#//Input:lists vec1 and vec2 of length 2
#//Output: ?

def angle_and_proj(vec1,vec2):#vec1 and
    u=vector(vec1)
    v=vector(vec2)
    l1=N(norm(u));l2=N(norm(v)) #norms of u and v
    temp=N(u.dot_product(v))# dot product <u,v> converted to the decimal form    ####temp=N(?)
    angle=N(arccos(temp/(l1*l2))) #Complete coding the formula for the angle b/w two vectors            ####angel= N(arccos..)
    proj=N(temp/l2) # Complete coding the formula for projection of u on the direction of v
    return angle,proj

#example
P,Q=angle_and_proj([3,0],[-2,3]);P;Q

︡ed584753-683b-450a-ac6b-1b2a75204f73︡{"stdout":"2.15879893034246\n-1.66410058867569\n"}︡{"done":true}
︠04485f28-2668-4c2b-8aec-f272c7e0ef29s︠
V=vector([-2,3]);norm(V);len(V)
︡f9d2c7ec-9d8a-4c48-8ba1-c2f25738524d︡{"stdout":"sqrt(13)\n2\n"}︡{"done":true}
︠702cff44-1ba8-4bec-8654-e62f85fdb80as︠
vector([1.,2.]).norm()
         #Exercise 2(a). Make a CAS function pt_line_distance(a, b, c, pt)  that takes coefficients         #a, b, c of the general equation of a line and coordinates pt = [x0, y0] of a point and returns the distance from the point to the line.
#(b) Make up an example and test your code using the example. Plot in one figure (i) the point, (ii) #the line, and (iii) a vector perpendicular to the line with its tail located at the given point.
#//Imput: ?
#//Output:distance from point to line defined by the equation ?
def pt_line_distance(a,b,c,pt):
    if b==0:
       return abs(pt[0]+c/d)
    else:
        n=vector([a,b]).norm()# length of a normal vector to the given line
        dist=(abs(a*pt[0]+b*pt[0]+c))/n #Encode the distance formula
        return dist
pt_line_distance(1,2.3,-1,[1,1.])
︡0f71d756-ca7c-442e-8153-23a75e73972a︡{"stdout":"2.23606797749979\n"}︡{"stdout":"0.917070056253235\n"}︡{"done":true}
︠ac07539a-c0e3-4b74-afae-51f5775704e5s︠
# Execise 2(b): Plotting
#//Input:?
#//Output:?
def ex2_plot(a,b,c,pt):
    line_plot=plot((-a/b)*x-(c/b),pt[0]-3.,pt[0]+3.,figsize=[4,3])# the range for x can be chosen differently
    pt_plot=point(pt,size=30,color='green',figsize=[4,3])
    n_plot=arrow((pt[0],pt[1]),(pt[0]+a,pt[1]+b))
    G=line_plot+pt_plot+n_plot
    G.show()



ex2_plot(1,2.3,-1,[1,1.])
︡a2c11d00-0af0-4167-9aba-cdca18a78670︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/307/tmp_w4xmra.svg","show":true,"text":null,"uuid":"02778589-dcd4-4965-8346-5de6cc67c4e8"},"once":false}︡{"done":true}
︠aeafaaa1-0578-461e-a8a5-7e1b9588e817︠

︡35b9ee74-1b93-4976-bdf4-76067d02ca86︡
︠5ad0919d-6e8b-4440-83c7-1ffacdfedc42s︠
#Exercise 3: Make a CAS function three_motions(pt, t, V, param) that takes coordinates pt  of a point, angle t, in radians, vector V,and parameter p. Your function should return a plot of the given point and its image under the following transformations:
#(a) translation defined by the vector V  if p = 0;
#(b) rotation defined by the angle t if p = 1;
#(c) reflection of the point in the y-axis if p = 2;
#Test you code for specific transformations of each of the three kinds of motions.

                   # Make this function w/out my template

︡13e25497-437f-4043-817d-1f9c8c1d19d5︡{"done":true}
︠299038b6-9411-4c8b-9d80-637795ba4493s︠
def rigid_motion(pt,t,v,p):
        if p==0:
             pt_image=point([(pt[0]+v[0],pt[1]+v[1])])
        elif p==1:
             a=cos(t);b=sin(t)
             pt_image=point([(a*pt[0]+b*pt[1],a*pt[0]-b*pt[1])])
        else:
             pt_image=(-pt[0],pt[1])
        return pt_image

rigid_motion([3,5],.8,vector([5,7]),2)







︡4701f021-cb2f-491c-b9ae-677d911a03f1︡{"stdout":"(-3, 5)\n"}︡{"done":true}
︠9c22d862-f990-434e-a8cf-56fc2cc463e0︠

#Exercise 7 (demo). Use CAS to substitute the expressions x = X*cos(t)-Y*sin(t), y = X*sin(t)+Y*cos(t) into the equation A*x^2+2*B*x*y+C*y^2=1. Find the coefficient of X*Y.
var('A B C x y t X Y')
expr=A*x^2+2*B*x*y+C*y^2
︡b28f0a1f-93a4-4651-bf29-9805870263ad︡{"stdout":"(A, B, C, x, y, t, X, Y)\n"}︡{"done":true}
︠5a2d5c6d-1970-48dc-a48b-1ae33243af5ds︠
expr1=expr.subs(x = X*cos(t)-Y*sin(t), y = X*sin(t)+Y*cos(t))
︡bbdf6475-c9a1-4518-890a-31f1a5fc15b6︡{"done":true}
︠22fe15b6-b47d-476e-99cc-38919b49ba4es︠
expr2=expand(expr1);expr2
︡9ad48a8f-d4d8-4e46-b112-d4f690f686ec︡{"stdout":"A*X^2*cos(t)^2 + 2*B*X*Y*cos(t)^2 + C*Y^2*cos(t)^2 + 2*B*X^2*cos(t)*sin(t) - 2*A*X*Y*cos(t)*sin(t) + 2*C*X*Y*cos(t)*sin(t) - 2*B*Y^2*cos(t)*sin(t) + C*X^2*sin(t)^2 - 2*B*X*Y*sin(t)^2 + A*Y^2*sin(t)^2\n"}︡{"done":true}
︠02425ca7-b0a1-40ae-926f-7db01e7e8b37s︠
expr3=(expr2.coefficient(X,n=1))/2;expr3
︡74e156de-272c-415e-98ac-f5311490550f︡{"stdout":"B*Y*cos(t)^2 - A*Y*cos(t)*sin(t) + C*Y*cos(t)*sin(t) - B*Y*sin(t)^2\n"}︡{"done":true}
︠60c74f97-bcce-47c1-a9b5-aac581b9d613s︠
expr3.coefficient(Y,n=1)
︡1eb058ca-3050-4f55-81f3-50c4c3b7a708︡{"stdout":"B*cos(t)^2 - A*cos(t)*sin(t) + C*cos(t)*sin(t) - B*sin(t)^2\n"}︡{"done":true}
︠bf63bcb5-23ca-42eb-91c6-46c360a74f69︠
#Manual solution of the equation (A-C)*sin(2*t)=2*B*cos(2*t): cot(2*t)=(A-C)/2*B.










